package com.example.fuzzControll.tools;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.example.fuzzControll.pojo.vo.TestReturnEntity;
import org.apache.commons.io.IOUtils;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;


public class LinuxCommandUtil {

    private Session session;
    private ChannelExec channelExec;

    /**
     * 默认执行本地linux指令
     */
    public static String exeLocLinuxCmd(String cmd) {
        String result = "";
        Runtime run = Runtime.getRuntime();
        try {
            Process process = run.exec(cmd);
            InputStream in = process.getInputStream();
            BufferedReader bs = new BufferedReader(new InputStreamReader(in));
            process.destroy();
            return result;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 远程执行linux指令
     */
    public static String exeLinuxBySSH(String host, int port, String user, String password, String command) throws JSchException, IOException {

        JSch jsch = new JSch();
        Session session = jsch.getSession(user, host, port);
        session.setConfig("StrictHostKeyChecking", "no");

        session.setPassword(password);
        session.connect();

        ChannelExec channelExec = (ChannelExec) session.openChannel("exec");
        InputStream in = channelExec.getInputStream();
        channelExec.setCommand(command);
        channelExec.setErrStream(System.err);
        channelExec.connect();
        String out = IOUtils.toString(in, "UTF-8");

        channelExec.disconnect();
        session.disconnect();

        return out;
    }

    /**
     * 创建连接
     */
    public Session connect(String host, int port, String user, String password) throws JSchException {
        JSch jsch = new JSch();
        session = jsch.getSession(user, host, port);
        session.setConfig("StrictHostKeyChecking", "no");

        session.setPassword(password);
        session.connect();

        channelExec = (ChannelExec) session.openChannel("exec");
        return session;
    }

    /**
     * 执行指令
     */
    public void execCmd(String command) throws JSchException, IOException {
        List<String> result = new ArrayList<>();
        InputStream in = channelExec.getInputStream();

        channelExec.setCommand(command);
        channelExec.setErrStream(System.err);
        channelExec.connect();

        Reader reader = new InputStreamReader(in);
        BufferedReader bf = new BufferedReader(reader);
        CmdTools cmdTools = new CmdTools();
        String line = null;
        TestReturnEntity returnEntity = new TestReturnEntity();
        try {
            while ((line = bf.readLine()) != null && TestControlTools.getIsRunning()) {
                System.out.println(line);
//                cmdTools.makeReturnEntity(line, returnEntity);
//                if (cmdTools.send) {
//                    String data = JSONObject.toJSONString(returnEntity);
//                    try {
//                        GlobalParameters.webSocket.appointSending("fuzzMaster", "web", data);
//                    } catch (Exception ignored) {
//                    }
//                }
            }
            //结束就关闭
            if(!TestControlTools.getIsRunning()){
                close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 关闭连接
     */
    public void close() {
        channelExec.disconnect();
        session.disconnect();
    }
}